
-- considering whether Scenario should no longer be a GameObject

-- need to run Step every frame (preferably from Game)
-- need to run GetPlayerInput every frame
-- ScenarioPlayerControls won't be a GameObject either

-- need new Setup function

-- References to "self.environment" to be replaced with "self.game.environment_gameplay" etc

-- TRAININGGROUNDS_Scenario = {}
-- TRAININGGROUNDS_Scenario.__index = TRAININGGROUNDS_Scenario
-- function TRAININGGROUNDS_Scenario.new()
	-- local self=setmetatable({}, TRAININGGROUNDS_Scenario)	
	-- return self
-- end
-- local super=nil
--local class=TRAININGGROUNDS_Scenario


-- function class:Setup(game)
	--self.game=game
-- end


-- function class:SetGameplayEnvironment(environment_gameplay)

-- end

-- function TRAININGGROUNDS_Game:StartScenario(scenario)
	-- self.scenario:Cleanup()
	-- self.environments[i]:Cleanup() -- (foreach)
	-- self.scenario=scenario
	-- scenario:SetGameplayEnvironment(self.environment_gameplay)
	-- scenario:Begin()
-- end





--TODO: we're still not 100% convinced Scenario should be a GameObject

TRAININGGROUNDS_Scenario = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_GameObject)
local class=TRAININGGROUNDS_Scenario

function TRAININGGROUNDS_Scenario:SetCustomInfo()
	TRAININGGROUNDS_GameObject.SetCustomInfo(self)

	self:SetCamera()
	
	self.visible=false
	
	self.combatlog=TRAININGGROUNDS_CombatLog.new()
	self.combatlog:Setup()
	
	self.scenariotime=0
	--TODO: array of events and maybe scenarioevent class
	self.nextevent=0.25
	
	self.raid=TRAININGGROUNDS_Raid.new()
	self.raid:Setup()
	
	self.currentplayer=nil	
	
	self.description="Flare, blaze, and taeshtech."
	
	
end


-- Override SetCamera if the environment uses a different camera (such as Camera_HUD).
-- TODO LATER: either leave comment about not calling super in overridden function, or change default camera to nil
function TRAININGGROUNDS_Scenario:SetCamera()
	self.environment.game.environment_gameplay.cameramanager.camera=TRAININGGROUNDS_Camera.new()
	self.environment.game.environment_gameplay.cameramanager.camera:Setup(self.environment.game.environment_gameplay)
end

function TRAININGGROUNDS_Scenario:GetPlayerInput(elapsed)
	--override
end
function TRAININGGROUNDS_Scenario:Step(elapsed)
	--TODO: use this, or use localtime?
	self.scenariotime=self.scenariotime+elapsed
	if(self.nextevent)then
		if(self.scenariotime>=self.nextevent)then
			
			self:Populate()
	
			self.nextevent=nil
		end
	end
	
	--TODO: combatlog:Step?
	-- also why is groupdancemodule owned by combatlog
	--  (i think ideally bosscontroller should own it) (and not scenario)
	for i=1,#self.combatlog.groupdancemodules do
		self.combatlog.groupdancemodules[i]:Step(elapsed)
	end
	
end

function TRAININGGROUNDS_Scenario:Populate()
	--return self.raid:Populate(self.environment.game.environment_gameplay)	
	--local controls = TRAININGGROUNDS_ScenarioPlayerControls.new()

			self:CreatePlayerControls()
			-- local currentplayer=self:Populate()
			-- --print(player)
			-- controls:SetPlayer(currentplayer)
			-- currentplayer:SetPlayerAppearance()
			-- local relevant=TRAININGGROUNDS_Aura_PlayerControlled.new()
			-- relevant:Setup(currentplayer.combat,currentplayer.combat,currentplayer:GetLocalTime())
			
			-- self.currentplayer=currentplayer			
	self:PopulatePlayerHUD()
end

function TRAININGGROUNDS_Scenario:CreatePlayerControls()
	local controls = TRAININGGROUNDS_ScenarioPlayerControls_CharacterMode.new()
	controls:Setup(self.environment,self)			
	self.controls=controls
end

function TRAININGGROUNDS_Scenario:PopulatePlayerHUD()
	-- override for scenarios which should not have player HUD elements
	
	--TODO: decide whether to call them "hotbars" or "actionbars"
	local env=self.environment.game.environment_hotbar
	self.actionbar=TRAININGGROUNDS_ActionBar.new()
	self.actionbar:Setup(env)

end

function TRAININGGROUNDS_Scenario:SetCurrentPlayer(mobile)
	self.currentplayer=mobile
	self.actionbar:SetCurrentPlayer(mobile)
	
end


function TRAININGGROUNDS_Scenario:GetRandomRangedTargetCombats(min_ranged,num_targets)	
	local targets={}
	
	if(not min_ranged)then min_ranged=3 end
	if(not num_targets)then num_targets=1 end
	
	local rangedtargets=self.raid:GetAllRangedTargets()
	if(#rangedtargets<min_ranged)then
		self.raid:GetAllTargets()
	end
	
	--print("GetRandomRangedTarget, first pass:",#rangedtargets,#targets,num_targets)
	--TODO: refine logic
	while(#rangedtargets>0 and #targets<num_targets)do		
		local i=math.floor((math.random()*#rangedtargets)+1)
		tinsert(targets,rangedtargets[i].combat)
		tremove(rangedtargets,i)
		--print("GetRandomRangedTarget, loop:",#rangedtargets,#targets,num_targets,i)
	end
	
	
	return targets
	
end

function TRAININGGROUNDS_Scenario:Cleanup()
	for i=1,#self.combatlog.groupdancemodules do
		self.combatlog.groupdancemodules[i]:Cleanup()
	end
	TRAININGGROUNDS_GameObject.Cleanup(self)

end

function TRAININGGROUNDS_Scenario:OnEscapeKey()
	--override, don't call super
	if(_TRAININGGROUNDS)then
		_TRAININGGROUNDS:Shutdown()
	end
end